<?php
if (!defined('ABSPATH'))
    exit;
/*
  Plugin Name: Social testimonials and reviews
  Description: Social testimonials & reviews on your own website as social proof. Increase your website's sales and conversion rate.
  Version: 4.70
 */

class RwIntegration {

    function __construct() {
        $this->plugin_url = plugin_dir_url(__FILE__);
        $this->pages_types = array('Front Page', 'Blog Index', 'Pages', 'Posts');
        $this->pages = array();
        $pages = get_posts(array(
            'post_type' => 'page',
            'posts_per_page' => -1
        ));

        $posts_page = get_option('page_for_posts');
        $front_page = get_option('page_on_front');

        foreach ($pages as $page) {
            if ($page->ID != $posts_page && $page->ID != $front_page) {
                $this->pages[] = $page;
            }
        }
    }

    function execute_sidewide_widget() {
        $show = false;
        $code = get_option('rw_js_code');
        if (trim($code) == '') {
            return true;
        }
        $rw_page_type_front_page = get_option('rw_page_type_front-page');
        $rw_page_type_blog_index = get_option('rw_page_type_blog-index');
        $rw_page_type_pages = get_option('rw_page_type_pages');
        $rw_page_type_posts = get_option('rw_page_type_posts');

        if ($rw_page_type_front_page == '1' && is_front_page()) {
            $show = true;
        }
        if ($rw_page_type_blog_index == '1' && is_home()) {
            $show = true;
        }
        if ($rw_page_type_pages == '1' && is_page()) {
            $show = true;
        }
        if ($rw_page_type_posts == '1' && is_single()) {
            $show = true;
        }


        if (is_page()) {
            $page_id = get_the_ID();
            //rw_page_show_6
            //rw_page_hide_2

            if (get_option('rw_page_show_' . $page_id) == '1') {
                $show = true;
            }
            if (get_option('rw_page_hide_' . $page_id) == '1') {
                $show = false;
            }
        }

        /* by url */

        $url_itself = get_option('url_itself');
        $url_type = get_option('url_type');
        
        if (is_array($url_itself) && !empty($url_itself)) {
            foreach ($url_itself as $key => $value) {
                
                $ru = str_replace('/','',$_SERVER['REQUEST_URI']);
                $va = str_replace('/','',$value);
               
                /*var_dump(fnmatch($value, '/sample-page/'));*/
                if(fnmatch($va, $ru) && $url_type[$key]=='show')
                {
                    $show = true;
                }
              
                
                if(fnmatch($va, $ru) && $url_type[$key]=='hide')
                {
                    $show = false;
                }
                
            }
        }



        if ($show) {
            echo stripslashes($code);
        }
        /* var_dump('test');
          die(); */
    }

    function init() {
        wp_enqueue_style('rw_css', plugin_dir_url(__FILE__) . 'css/rw-front.css');
    }

    function admin_enqueue_scripts() {
        wp_enqueue_style('rw_css_admin', $this->plugin_url . 'css/rw-admin.css');
        wp_enqueue_script('rw_js_admin', $this->plugin_url . 'js/rw-admin.js');
    }

    function admin_menu() {
        global $submenu;
        add_menu_page('Rw', 'Testimonials', 'manage_options', 'rw_integration_wl', array($this, 'pagewide_widget'), 'dashicons-star-filled');
        //add_submenu_page('rw_integration_wl', 'Manage', 'Dashboard', 'manage_options', 'rw_integration_wl', array($this, 'rw'));
        add_submenu_page('rw_integration_wl', 'Floating Widget', 'Floating Widget', 'manage_options', 'pagewide_widget_wl', array($this, 'pagewide_widget'));
        add_submenu_page('rw_integration_wl', 'Shortcodes', 'Shortcodes', 'manage_options', 'grid_shortcode_wl', array($this, 'rw_grid_generator'));
        $submenu['rw_integration_wl'][] = array('<span class="target-blank">Dashboard <i class="dashicons-before dashicons-external"></i></span>', 'manage_options', 'https://app.thereviewsplace.com/?platform=wordpress#/login', 'rw_dashboard_wl', '');
        remove_submenu_page('rw_integration_wl','rw_integration_wl'); // remove duplicated parent menu item that appear as child
        
    }

    function rw_grid_generator() {
        require_once dirname(__FILE__) . '/tmpl/shortcodes.php';
    }

    function pagewide_widget() {
        $saved = false;
        if (!empty($_POST) && isset($_POST['repulso_save']) && current_user_can('manage_options')) {
            if (!empty($_POST['url_itself'])) {
                foreach ($_POST['url_itself'] as $key => $value) {
                    if (trim($value) == '') {
                        unset($_POST['url_itself'][$key]);
                        unset($_POST['url_type'][$key]);
                    }
                }
            }
            foreach ($_POST as $key => $value) {
                update_option($key, $value);
            }
            $saved = true;
        }
        require_once dirname(__FILE__) . '/tmpl/floating.php';
    }

    function rw_grid($args) {
	    return $this->get_widget_code("grid", $args);
    }
    
    function rw_inline($args) {
	    return $this->get_widget_code("inline", $args);
    }
    
    function rw_photoset($args) {
	    return $this->get_widget_code("photoset", $args);
    }
    
    function rw_badge1($args) {
	    return $this->get_widget_code("badge1", $args);
    }
    
    function rw_masonry($args) {
	    return $this->get_widget_code("masonry", $args);
    }
    
    function rw_mediawall($args) {
	    return $this->get_widget_code("mediawall", $args);
    }

    function rw_list($args) {
	    return $this->get_widget_code("list", $args);
    }
    
    function rw_slider($args) {
	    return $this->get_widget_code("slider", $args);
    }
    
    function rw_badge2($args) {
	    return $this->get_widget_code("badge2", $args);
    }
    
    function get_widget_code($type, $args) {
	    ob_start();
        if (isset($args['id'])) {
            $id = $args['id'];
            $code = '';
            
            unset($args['id']);
            if(is_array($args)) {
	            foreach($args as $key => $value)
	            	$code.= ' '.$key.'="'.$value.'"';
            }
            ?>
            <!-- Begin widget code -->
            <rw-widget-<?php echo $type?> data-rw-<?php echo $type?>="<?php echo $id ?>"<?php echo $code; ?>></rw-widget-<?php echo $type?>>
			<script data-cfasync="false" crossorigin="anonymous" type="module" src="https://widgets.thereviewsplace.com/2.0/rw-widget-<?php echo $type?>.js"></script>
            <!-- End widget code -->
            <?php
        }

        return ob_get_clean();
    }

    /* function settings() {
      if (current_user_can('manage_options')) {
      if (isset($_POST['daashub_token'])) {
      update_option('daashub_token', sanitize_text_field($_POST['daashub_token']));
      }
      require_once dirname(__FILE__) . '/tmpl/settings.php';
      } else {
      die('Restricted access!');
      }
      } */
}

$da = new RwIntegration();
add_action('init', array($da, 'init'));
add_action('wp_footer', array($da, 'execute_sidewide_widget'));
add_shortcode('rw_grid', array($da, 'rw_grid'));
add_shortcode('rw_inline', array($da, 'rw_inline'));
add_shortcode('rw_photoset', array($da, 'rw_photoset'));
add_shortcode('rw_badge1', array($da, 'rw_badge1'));
add_shortcode('rw_masonry', array($da, 'rw_masonry'));
add_shortcode('rw_mediawall', array($da, 'rw_mediawall'));
add_shortcode('rw_list', array($da, 'rw_list'));
add_shortcode('rw_slider', array($da, 'rw_slider'));
add_shortcode('rw_badge2', array($da, 'rw_badge2'));
add_action('admin_enqueue_scripts', array($da, 'admin_enqueue_scripts'));
add_action('admin_menu', array($da, 'admin_menu'));
